﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace XamGridHorizontalScrolling
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private static int colCount = 40;
        public List<object> Data = GetData();

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;
            MainGrid.ColumnLayouts.Add(GenerateColumnLayout());
        }

        private ColumnLayout GenerateColumnLayout()
        {
            ColumnLayout columnLayout = new ColumnLayout() { Key = "XamWebGrid_Root_XamWebGrid" };
            var r = new Random();
            var cols = new List<Column>();
            for (int i = 0; i < colCount; i++)
            {
                cols.Add(new TextColumn()
                {
                    HeaderText = "Column "+i,
                    Key = "[Column "+i+"]"
                });
            }

            var id = 0;
            var num = 5;
            while (cols.Count > 2*num)
            {
                var subs = new List<Column>();
                for (int i = 0; i < num; i++)
                {
                    subs.Add(cols[cols.Count - 1]);
                    cols.RemoveAt(cols.Count - 1);
                }

                var group = new GroupColumn() { HeaderText = "Group Header" + (++id), Key = id + "" };
                foreach (var col in subs)
                    group.Columns.Add(col);
                cols.Add(group);

                subs = new List<Column>();
                for (int i = 0; i < num; i++)
                {
                    subs.Add(cols[0]);
                    cols.RemoveAt(0);
                }

                group = new GroupColumn() { HeaderText = "Group Header" + (++id), Key = id + "" };
                foreach (var col in subs)
                    group.Columns.Add(col);
                cols.Add(group);
            }

            //var id = 0;
            //while(id < 20 && cols.Count > 2)
            //{
            //    var next = cols[r.Next(cols.Count)];
            //    cols.Remove(next);

            //    var next2 = cols[r.Next(cols.Count)];
            //    cols.Remove(next2);

            //    var group = new GroupColumn() { HeaderText = "" + (++id), Key = id+"" };
            //    group.Columns.Add(next);
            //    group.Columns.Add(next2);
            //    cols.Add(group);
            //}
            foreach (var col in cols)
                columnLayout.Columns.Add(col);
            return columnLayout;
        }

        public static List<object> GetData()
        {
            var dict = new Dictionary<string, object>();
            for (int i = 0; i < colCount; i++)
                dict["Column " + i] = null;
            return new List<object>() { dict };
        }
    }
}
